// Copyright (c) 2005-2017 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

#include "cmtl.h"

namespace GroupPolicy
{
  namespace CommentDefinitions
  {
    // CommentDefinitionResources
    // 

    const CommentDefinitionResources::ResourcesType& CommentDefinitionResources::
    resources () const
    {
      return this->resources_.get ();
    }

    CommentDefinitionResources::ResourcesType& CommentDefinitionResources::
    resources ()
    {
      return this->resources_.get ();
    }

    void CommentDefinitionResources::
    resources (const ResourcesType& x)
    {
      this->resources_.set (x);
    }

    void CommentDefinitionResources::
    resources (::std::unique_ptr< ResourcesType > x)
    {
      this->resources_.set (std::move (x));
    }

    const CommentDefinitionResources::RevisionType& CommentDefinitionResources::
    revision () const
    {
      return this->revision_.get ();
    }

    CommentDefinitionResources::RevisionType& CommentDefinitionResources::
    revision ()
    {
      return this->revision_.get ();
    }

    void CommentDefinitionResources::
    revision (const RevisionType& x)
    {
      this->revision_.set (x);
    }

    const CommentDefinitionResources::SchemaVersionType& CommentDefinitionResources::
    schemaVersion () const
    {
      return this->schemaVersion_.get ();
    }

    CommentDefinitionResources::SchemaVersionType& CommentDefinitionResources::
    schemaVersion ()
    {
      return this->schemaVersion_.get ();
    }

    void CommentDefinitionResources::
    schemaVersion (const SchemaVersionType& x)
    {
      this->schemaVersion_.set (x);
    }


    // Resources
    // 

    const Resources::StringTableType& Resources::
    stringTable () const
    {
      return this->stringTable_.get ();
    }

    Resources::StringTableType& Resources::
    stringTable ()
    {
      return this->stringTable_.get ();
    }

    void Resources::
    stringTable (const StringTableType& x)
    {
      this->stringTable_.set (x);
    }

    void Resources::
    stringTable (::std::unique_ptr< StringTableType > x)
    {
      this->stringTable_.set (std::move (x));
    }


    // StringTable
    // 

    const StringTable::StringSequence& StringTable::
    string () const
    {
      return this->string_;
    }

    StringTable::StringSequence& StringTable::
    string ()
    {
      return this->string_;
    }

    void StringTable::
    string (const StringSequence& s)
    {
      this->string_ = s;
    }


    // String
    // 

    const String::IdType& String::
    id () const
    {
      return this->id_.get ();
    }

    String::IdType& String::
    id ()
    {
      return this->id_.get ();
    }

    void String::
    id (const IdType& x)
    {
      this->id_.set (x);
    }

    void String::
    id (::std::unique_ptr< IdType > x)
    {
      this->id_.set (std::move (x));
    }
  }
}

#include <xsd/cxx/xml/dom/wildcard-source.hxx>

#include <xsd/cxx/xml/dom/parsing-source.hxx>

#include <xsd/cxx/tree/type-factory-map.hxx>

namespace _xsd
{
  static
  const ::xsd::cxx::tree::type_factory_plate< 0, char >
  type_factory_plate_init;
}

namespace GroupPolicy
{
  namespace CommentDefinitions
  {
    // CommentDefinitionResources
    //

    CommentDefinitionResources::
    CommentDefinitionResources (const ResourcesType& resources,
                                const RevisionType& revision,
                                const SchemaVersionType& schemaVersion)
    : ::xml_schema::Type (),
      resources_ (resources, this),
      revision_ (revision, this),
      schemaVersion_ (schemaVersion, this)
    {
    }

    CommentDefinitionResources::
    CommentDefinitionResources (::std::unique_ptr< ResourcesType > resources,
                                const RevisionType& revision,
                                const SchemaVersionType& schemaVersion)
    : ::xml_schema::Type (),
      resources_ (std::move (resources), this),
      revision_ (revision, this),
      schemaVersion_ (schemaVersion, this)
    {
    }

    CommentDefinitionResources::
    CommentDefinitionResources (const CommentDefinitionResources& x,
                                ::xml_schema::Flags f,
                                ::xml_schema::Container* c)
    : ::xml_schema::Type (x, f, c),
      resources_ (x.resources_, f, this),
      revision_ (x.revision_, f, this),
      schemaVersion_ (x.schemaVersion_, f, this)
    {
    }

    CommentDefinitionResources::
    CommentDefinitionResources (const ::xercesc::DOMElement& e,
                                ::xml_schema::Flags f,
                                ::xml_schema::Container* c)
    : ::xml_schema::Type (e, f | ::xml_schema::Flags::base, c),
      resources_ (this),
      revision_ (this),
      schemaVersion_ (this)
    {
      if ((f & ::xml_schema::Flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, true);
        this->parse (p, f);
      }
    }

    void CommentDefinitionResources::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::Flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // resources
        //
        if (n.name () == "resources" && n.namespace_ () == "http://www.microsoft.com/GroupPolicy/CommentDefinitions")
        {
          ::std::unique_ptr< ResourcesType > r (
            ResourcesTraits::create (i, f, this));

          if (!resources_.present ())
          {
            this->resources_.set (::std::move (r));
            continue;
          }
        }

        break;
      }

      if (!resources_.present ())
      {
        throw ::xsd::cxx::tree::expected_element< char > (
          "resources",
          "http://www.microsoft.com/GroupPolicy/CommentDefinitions");
      }

      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "revision" && n.namespace_ ().empty ())
        {
          this->revision_.set (RevisionTraits::create (i, f, this));
          continue;
        }

        if (n.name () == "schemaVersion" && n.namespace_ ().empty ())
        {
          this->schemaVersion_.set (SchemaVersionTraits::create (i, f, this));
          continue;
        }
      }

      if (!revision_.present ())
      {
        throw ::xsd::cxx::tree::expected_attribute< char > (
          "revision",
          "");
      }

      if (!schemaVersion_.present ())
      {
        throw ::xsd::cxx::tree::expected_attribute< char > (
          "schemaVersion",
          "");
      }
    }

    CommentDefinitionResources* CommentDefinitionResources::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class CommentDefinitionResources (*this, f, c);
    }

    CommentDefinitionResources& CommentDefinitionResources::
    operator= (const CommentDefinitionResources& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::Type& > (*this) = x;
        this->resources_ = x.resources_;
        this->revision_ = x.revision_;
        this->schemaVersion_ = x.schemaVersion_;
      }

      return *this;
    }

    CommentDefinitionResources::
    ~CommentDefinitionResources ()
    {
    }

    // Resources
    //

    Resources::
    Resources (const StringTableType& stringTable)
    : ::xml_schema::Type (),
      stringTable_ (stringTable, this)
    {
    }

    Resources::
    Resources (::std::unique_ptr< StringTableType > stringTable)
    : ::xml_schema::Type (),
      stringTable_ (std::move (stringTable), this)
    {
    }

    Resources::
    Resources (const Resources& x,
               ::xml_schema::Flags f,
               ::xml_schema::Container* c)
    : ::xml_schema::Type (x, f, c),
      stringTable_ (x.stringTable_, f, this)
    {
    }

    Resources::
    Resources (const ::xercesc::DOMElement& e,
               ::xml_schema::Flags f,
               ::xml_schema::Container* c)
    : ::xml_schema::Type (e, f | ::xml_schema::Flags::base, c),
      stringTable_ (this)
    {
      if ((f & ::xml_schema::Flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
        this->parse (p, f);
      }
    }

    void Resources::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::Flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // stringTable
        //
        if (n.name () == "stringTable" && n.namespace_ () == "http://www.microsoft.com/GroupPolicy/CommentDefinitions")
        {
          ::std::unique_ptr< StringTableType > r (
            StringTableTraits::create (i, f, this));

          if (!stringTable_.present ())
          {
            this->stringTable_.set (::std::move (r));
            continue;
          }
        }

        break;
      }

      if (!stringTable_.present ())
      {
        throw ::xsd::cxx::tree::expected_element< char > (
          "stringTable",
          "http://www.microsoft.com/GroupPolicy/CommentDefinitions");
      }
    }

    Resources* Resources::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Resources (*this, f, c);
    }

    Resources& Resources::
    operator= (const Resources& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::Type& > (*this) = x;
        this->stringTable_ = x.stringTable_;
      }

      return *this;
    }

    Resources::
    ~Resources ()
    {
    }

    // StringTable
    //

    StringTable::
    StringTable ()
    : ::xml_schema::Type (),
      string_ (this)
    {
    }

    StringTable::
    StringTable (const StringTable& x,
                 ::xml_schema::Flags f,
                 ::xml_schema::Container* c)
    : ::xml_schema::Type (x, f, c),
      string_ (x.string_, f, this)
    {
    }

    StringTable::
    StringTable (const ::xercesc::DOMElement& e,
                 ::xml_schema::Flags f,
                 ::xml_schema::Container* c)
    : ::xml_schema::Type (e, f | ::xml_schema::Flags::base, c),
      string_ (this)
    {
      if ((f & ::xml_schema::Flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
        this->parse (p, f);
      }
    }

    void StringTable::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::Flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // string
        //
        if (n.name () == "string" && n.namespace_ () == "http://www.microsoft.com/GroupPolicy/CommentDefinitions")
        {
          ::std::unique_ptr< StringType > r (
            StringTraits::create (i, f, this));

          this->string_.push_back (::std::move (r));
          continue;
        }

        break;
      }
    }

    StringTable* StringTable::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class StringTable (*this, f, c);
    }

    StringTable& StringTable::
    operator= (const StringTable& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::Type& > (*this) = x;
        this->string_ = x.string_;
      }

      return *this;
    }

    StringTable::
    ~StringTable ()
    {
    }

    // String
    //

    String::
    String (const IdType& id)
    : ::xml_schema::String (),
      id_ (id, this)
    {
    }

    String::
    String (const char* _xsd_String_base,
            const IdType& id)
    : ::xml_schema::String (_xsd_String_base),
      id_ (id, this)
    {
    }

    String::
    String (const ::std::string& _xsd_String_base,
            const IdType& id)
    : ::xml_schema::String (_xsd_String_base),
      id_ (id, this)
    {
    }

    String::
    String (const ::xml_schema::String& _xsd_String_base,
            const IdType& id)
    : ::xml_schema::String (_xsd_String_base),
      id_ (id, this)
    {
    }

    String::
    String (const String& x,
            ::xml_schema::Flags f,
            ::xml_schema::Container* c)
    : ::xml_schema::String (x, f, c),
      id_ (x.id_, f, this)
    {
    }

    String::
    String (const ::xercesc::DOMElement& e,
            ::xml_schema::Flags f,
            ::xml_schema::Container* c)
    : ::xml_schema::String (e, f | ::xml_schema::Flags::base, c),
      id_ (this)
    {
      if ((f & ::xml_schema::Flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, false, false, true);
        this->parse (p, f);
      }
    }

    void String::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::Flags f)
    {
      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "id" && n.namespace_ ().empty ())
        {
          this->id_.set (IdTraits::create (i, f, this));
          continue;
        }
      }

      if (!id_.present ())
      {
        throw ::xsd::cxx::tree::expected_attribute< char > (
          "id",
          "");
      }
    }

    String* String::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class String (*this, f, c);
    }

    String& String::
    operator= (const String& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::String& > (*this) = x;
        this->id_ = x.id_;
      }

      return *this;
    }

    String::
    ~String ()
    {
    }
  }
}

#include <ostream>

#include <xsd/cxx/tree/std-ostream-map.hxx>

namespace _xsd
{
  static
  const ::xsd::cxx::tree::std_ostream_plate< 0, char >
  std_ostream_plate_init;
}

namespace GroupPolicy
{
  namespace CommentDefinitions
  {
    ::std::ostream&
    operator<< (::std::ostream& o, const CommentDefinitionResources& i)
    {
      o << ::std::endl << "resources: " << i.resources ();
      o << ::std::endl << "revision: " << i.revision ();
      o << ::std::endl << "schemaVersion: " << i.schemaVersion ();
      return o;
    }

    ::std::ostream&
    operator<< (::std::ostream& o, const Resources& i)
    {
      o << ::std::endl << "stringTable: " << i.stringTable ();
      return o;
    }

    ::std::ostream&
    operator<< (::std::ostream& o, const StringTable& i)
    {
      for (StringTable::StringConstIterator
           b (i.string ().begin ()), e (i.string ().end ());
           b != e; ++b)
      {
        o << ::std::endl << "string: " << *b;
      }

      return o;
    }

    ::std::ostream&
    operator<< (::std::ostream& o, const String& i)
    {
      o << static_cast< const ::xml_schema::String& > (i);

      o << ::std::endl << "id: " << i.id ();
      return o;
    }
  }
}

#include <istream>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

namespace GroupPolicy
{
  namespace CommentDefinitions
  {
    ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources >
    commentDefinitionResources (const ::std::string& u,
                                ::xml_schema::Flags f,
                                const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0,
        (f & ::xml_schema::Flags::keep_dom) == 0);

      ::xsd::cxx::tree::error_handler< char > h;

      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

      return ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources > (
        ::GroupPolicy::CommentDefinitions::commentDefinitionResources (
          std::move (d), f | ::xml_schema::Flags::own_dom, p));
    }

    ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources >
    commentDefinitionResources (const ::std::string& u,
                                ::xml_schema::ErrorHandler& h,
                                ::xml_schema::Flags f,
                                const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0,
        (f & ::xml_schema::Flags::keep_dom) == 0);

      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources > (
        ::GroupPolicy::CommentDefinitions::commentDefinitionResources (
          std::move (d), f | ::xml_schema::Flags::own_dom, p));
    }

    ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources >
    commentDefinitionResources (const ::std::string& u,
                                ::xercesc::DOMErrorHandler& h,
                                ::xml_schema::Flags f,
                                const ::xml_schema::Properties& p)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources > (
        ::GroupPolicy::CommentDefinitions::commentDefinitionResources (
          std::move (d), f | ::xml_schema::Flags::own_dom, p));
    }

    ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources >
    commentDefinitionResources (::std::istream& is,
                                ::xml_schema::Flags f,
                                const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0,
        (f & ::xml_schema::Flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::GroupPolicy::CommentDefinitions::commentDefinitionResources (isrc, f, p);
    }

    ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources >
    commentDefinitionResources (::std::istream& is,
                                ::xml_schema::ErrorHandler& h,
                                ::xml_schema::Flags f,
                                const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0,
        (f & ::xml_schema::Flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::GroupPolicy::CommentDefinitions::commentDefinitionResources (isrc, h, f, p);
    }

    ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources >
    commentDefinitionResources (::std::istream& is,
                                ::xercesc::DOMErrorHandler& h,
                                ::xml_schema::Flags f,
                                const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::GroupPolicy::CommentDefinitions::commentDefinitionResources (isrc, h, f, p);
    }

    ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources >
    commentDefinitionResources (::std::istream& is,
                                const ::std::string& sid,
                                ::xml_schema::Flags f,
                                const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0,
        (f & ::xml_schema::Flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::GroupPolicy::CommentDefinitions::commentDefinitionResources (isrc, f, p);
    }

    ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources >
    commentDefinitionResources (::std::istream& is,
                                const ::std::string& sid,
                                ::xml_schema::ErrorHandler& h,
                                ::xml_schema::Flags f,
                                const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0,
        (f & ::xml_schema::Flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::GroupPolicy::CommentDefinitions::commentDefinitionResources (isrc, h, f, p);
    }

    ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources >
    commentDefinitionResources (::std::istream& is,
                                const ::std::string& sid,
                                ::xercesc::DOMErrorHandler& h,
                                ::xml_schema::Flags f,
                                const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::GroupPolicy::CommentDefinitions::commentDefinitionResources (isrc, h, f, p);
    }

    ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources >
    commentDefinitionResources (::xercesc::InputSource& i,
                                ::xml_schema::Flags f,
                                const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::tree::error_handler< char > h;

      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

      return ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources > (
        ::GroupPolicy::CommentDefinitions::commentDefinitionResources (
          std::move (d), f | ::xml_schema::Flags::own_dom, p));
    }

    ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources >
    commentDefinitionResources (::xercesc::InputSource& i,
                                ::xml_schema::ErrorHandler& h,
                                ::xml_schema::Flags f,
                                const ::xml_schema::Properties& p)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources > (
        ::GroupPolicy::CommentDefinitions::commentDefinitionResources (
          std::move (d), f | ::xml_schema::Flags::own_dom, p));
    }

    ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources >
    commentDefinitionResources (::xercesc::InputSource& i,
                                ::xercesc::DOMErrorHandler& h,
                                ::xml_schema::Flags f,
                                const ::xml_schema::Properties& p)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources > (
        ::GroupPolicy::CommentDefinitions::commentDefinitionResources (
          std::move (d), f | ::xml_schema::Flags::own_dom, p));
    }

    ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources >
    commentDefinitionResources (const ::xercesc::DOMDocument& doc,
                                ::xml_schema::Flags f,
                                const ::xml_schema::Properties& p)
    {
      if (f & ::xml_schema::Flags::keep_dom)
      {
        ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
          static_cast< ::xercesc::DOMDocument* > (doc.cloneNode (true)));

        return ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources > (
          ::GroupPolicy::CommentDefinitions::commentDefinitionResources (
            std::move (d), f | ::xml_schema::Flags::own_dom, p));
      }

      const ::xercesc::DOMElement& e (*doc.getDocumentElement ());
      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (n.name () == "commentDefinitionResources" &&
          n.namespace_ () == "http://www.microsoft.com/GroupPolicy/CommentDefinitions")
      {
        ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources > r (
          ::xsd::cxx::tree::traits< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources, char >::create (
            e, f, 0));
        return r;
      }

      throw ::xsd::cxx::tree::unexpected_element < char > (
        n.name (),
        n.namespace_ (),
        "commentDefinitionResources",
        "http://www.microsoft.com/GroupPolicy/CommentDefinitions");
    }

    ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources >
    commentDefinitionResources (::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d,
                                ::xml_schema::Flags f,
                                const ::xml_schema::Properties&)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > c (
        ((f & ::xml_schema::Flags::keep_dom) &&
         !(f & ::xml_schema::Flags::own_dom))
        ? static_cast< ::xercesc::DOMDocument* > (d->cloneNode (true))
        : 0);

      ::xercesc::DOMDocument& doc (c.get () ? *c : *d);
      const ::xercesc::DOMElement& e (*doc.getDocumentElement ());

      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (f & ::xml_schema::Flags::keep_dom)
        doc.setUserData (::xml_schema::dom::tree_node_key,
                         (c.get () ? &c : &d),
                         0);

      if (n.name () == "commentDefinitionResources" &&
          n.namespace_ () == "http://www.microsoft.com/GroupPolicy/CommentDefinitions")
      {
        ::std::unique_ptr< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources > r (
          ::xsd::cxx::tree::traits< ::GroupPolicy::CommentDefinitions::CommentDefinitionResources, char >::create (
            e, f, 0));
        return r;
      }

      throw ::xsd::cxx::tree::unexpected_element < char > (
        n.name (),
        n.namespace_ (),
        "commentDefinitionResources",
        "http://www.microsoft.com/GroupPolicy/CommentDefinitions");
    }
  }
}

#include <ostream>
#include <xsd/cxx/tree/error-handler.hxx>
#include <xsd/cxx/xml/dom/serialization-source.hxx>

#include <xsd/cxx/tree/type-serializer-map.hxx>

namespace _xsd
{
  static
  const ::xsd::cxx::tree::type_serializer_plate< 0, char >
  type_serializer_plate_init;
}

namespace GroupPolicy
{
  namespace CommentDefinitions
  {
    void
    commentDefinitionResources (::std::ostream& o,
                                const ::GroupPolicy::CommentDefinitions::CommentDefinitionResources& s,
                                const ::xml_schema::NamespaceInfomap& m,
                                const ::std::string& e,
                                ::xml_schema::Flags f)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0);

      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::GroupPolicy::CommentDefinitions::commentDefinitionResources (s, m, f));

      ::xsd::cxx::tree::error_handler< char > h;

      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
      }
    }

    void
    commentDefinitionResources (::std::ostream& o,
                                const ::GroupPolicy::CommentDefinitions::CommentDefinitionResources& s,
                                ::xml_schema::ErrorHandler& h,
                                const ::xml_schema::NamespaceInfomap& m,
                                const ::std::string& e,
                                ::xml_schema::Flags f)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0);

      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::GroupPolicy::CommentDefinitions::commentDefinitionResources (s, m, f));
      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    commentDefinitionResources (::std::ostream& o,
                                const ::GroupPolicy::CommentDefinitions::CommentDefinitionResources& s,
                                ::xercesc::DOMErrorHandler& h,
                                const ::xml_schema::NamespaceInfomap& m,
                                const ::std::string& e,
                                ::xml_schema::Flags f)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::GroupPolicy::CommentDefinitions::commentDefinitionResources (s, m, f));
      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    commentDefinitionResources (::xercesc::XMLFormatTarget& t,
                                const ::GroupPolicy::CommentDefinitions::CommentDefinitionResources& s,
                                const ::xml_schema::NamespaceInfomap& m,
                                const ::std::string& e,
                                ::xml_schema::Flags f)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::GroupPolicy::CommentDefinitions::commentDefinitionResources (s, m, f));

      ::xsd::cxx::tree::error_handler< char > h;

      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
      }
    }

    void
    commentDefinitionResources (::xercesc::XMLFormatTarget& t,
                                const ::GroupPolicy::CommentDefinitions::CommentDefinitionResources& s,
                                ::xml_schema::ErrorHandler& h,
                                const ::xml_schema::NamespaceInfomap& m,
                                const ::std::string& e,
                                ::xml_schema::Flags f)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::GroupPolicy::CommentDefinitions::commentDefinitionResources (s, m, f));
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    commentDefinitionResources (::xercesc::XMLFormatTarget& t,
                                const ::GroupPolicy::CommentDefinitions::CommentDefinitionResources& s,
                                ::xercesc::DOMErrorHandler& h,
                                const ::xml_schema::NamespaceInfomap& m,
                                const ::std::string& e,
                                ::xml_schema::Flags f)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::GroupPolicy::CommentDefinitions::commentDefinitionResources (s, m, f));
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    commentDefinitionResources (::xercesc::DOMDocument& d,
                                const ::GroupPolicy::CommentDefinitions::CommentDefinitionResources& s,
                                ::xml_schema::Flags)
    {
      ::xercesc::DOMElement& e (*d.getDocumentElement ());
      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (n.name () == "commentDefinitionResources" &&
          n.namespace_ () == "http://www.microsoft.com/GroupPolicy/CommentDefinitions")
      {
        e << s;
      }
      else
      {
        throw ::xsd::cxx::tree::unexpected_element < char > (
          n.name (),
          n.namespace_ (),
          "commentDefinitionResources",
          "http://www.microsoft.com/GroupPolicy/CommentDefinitions");
      }
    }

    ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument >
    commentDefinitionResources (const ::GroupPolicy::CommentDefinitions::CommentDefinitionResources& s,
                                const ::xml_schema::NamespaceInfomap& m,
                                ::xml_schema::Flags f)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::serialize< char > (
          "commentDefinitionResources",
          "http://www.microsoft.com/GroupPolicy/CommentDefinitions",
          m, f));

      ::GroupPolicy::CommentDefinitions::commentDefinitionResources (*d, s, f);
      return d;
    }

    void
    operator<< (::xercesc::DOMElement& e, const CommentDefinitionResources& i)
    {
      e << static_cast< const ::xml_schema::Type& > (i);

      // resources
      //
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "resources",
            "http://www.microsoft.com/GroupPolicy/CommentDefinitions",
            e));

        s << i.resources ();
      }

      // revision
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "revision",
            e));

        a << ::xml_schema::AsDecimal(i.revision ());
      }

      // schemaVersion
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "schemaVersion",
            e));

        a << ::xml_schema::AsDecimal(i.schemaVersion ());
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const Resources& i)
    {
      e << static_cast< const ::xml_schema::Type& > (i);

      // stringTable
      //
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "stringTable",
            "http://www.microsoft.com/GroupPolicy/CommentDefinitions",
            e));

        s << i.stringTable ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const StringTable& i)
    {
      e << static_cast< const ::xml_schema::Type& > (i);

      // string
      //
      for (StringTable::StringConstIterator
           b (i.string ().begin ()), n (i.string ().end ());
           b != n; ++b)
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "string",
            "http://www.microsoft.com/GroupPolicy/CommentDefinitions",
            e));

        s << *b;
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const String& i)
    {
      e << static_cast< const ::xml_schema::String& > (i);

      // id
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "id",
            e));

        a << i.id ();
      }
    }
  }
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

