// Copyright (c) 2005-2017 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

#include "filesschema.h"

// FileProperties_t
// 

const FileProperties_t::ActionOptional& FileProperties_t::
action () const
{
  return this->action_;
}

FileProperties_t::ActionOptional& FileProperties_t::
action ()
{
  return this->action_;
}

void FileProperties_t::
action (const ActionType& x)
{
  this->action_.set (x);
}

void FileProperties_t::
action (const ActionOptional& x)
{
  this->action_ = x;
}

void FileProperties_t::
action (::std::unique_ptr< ActionType > x)
{
  this->action_.set (std::move (x));
}

const FileProperties_t::FromPathOptional& FileProperties_t::
fromPath () const
{
  return this->fromPath_;
}

FileProperties_t::FromPathOptional& FileProperties_t::
fromPath ()
{
  return this->fromPath_;
}

void FileProperties_t::
fromPath (const FromPathType& x)
{
  this->fromPath_.set (x);
}

void FileProperties_t::
fromPath (const FromPathOptional& x)
{
  this->fromPath_ = x;
}

void FileProperties_t::
fromPath (::std::unique_ptr< FromPathType > x)
{
  this->fromPath_.set (std::move (x));
}

const FileProperties_t::TargetPathType& FileProperties_t::
targetPath () const
{
  return this->targetPath_.get ();
}

FileProperties_t::TargetPathType& FileProperties_t::
targetPath ()
{
  return this->targetPath_.get ();
}

void FileProperties_t::
targetPath (const TargetPathType& x)
{
  this->targetPath_.set (x);
}

void FileProperties_t::
targetPath (::std::unique_ptr< TargetPathType > x)
{
  this->targetPath_.set (std::move (x));
}

const FileProperties_t::ReadOnlyOptional& FileProperties_t::
readOnly () const
{
  return this->readOnly_;
}

FileProperties_t::ReadOnlyOptional& FileProperties_t::
readOnly ()
{
  return this->readOnly_;
}

void FileProperties_t::
readOnly (const ReadOnlyType& x)
{
  this->readOnly_.set (x);
}

void FileProperties_t::
readOnly (const ReadOnlyOptional& x)
{
  this->readOnly_ = x;
}

const FileProperties_t::ArchiveOptional& FileProperties_t::
archive () const
{
  return this->archive_;
}

FileProperties_t::ArchiveOptional& FileProperties_t::
archive ()
{
  return this->archive_;
}

void FileProperties_t::
archive (const ArchiveType& x)
{
  this->archive_.set (x);
}

void FileProperties_t::
archive (const ArchiveOptional& x)
{
  this->archive_ = x;
}

const FileProperties_t::HiddenOptional& FileProperties_t::
hidden () const
{
  return this->hidden_;
}

FileProperties_t::HiddenOptional& FileProperties_t::
hidden ()
{
  return this->hidden_;
}

void FileProperties_t::
hidden (const HiddenType& x)
{
  this->hidden_.set (x);
}

void FileProperties_t::
hidden (const HiddenOptional& x)
{
  this->hidden_ = x;
}

const FileProperties_t::ExecutableOptional& FileProperties_t::
executable () const
{
  return this->executable_;
}

FileProperties_t::ExecutableOptional& FileProperties_t::
executable ()
{
  return this->executable_;
}

void FileProperties_t::
executable (const ExecutableType& x)
{
  this->executable_.set (x);
}

void FileProperties_t::
executable (const ExecutableOptional& x)
{
  this->executable_ = x;
}

const FileProperties_t::SuppressOptional& FileProperties_t::
suppress () const
{
  return this->suppress_;
}

FileProperties_t::SuppressOptional& FileProperties_t::
suppress ()
{
  return this->suppress_;
}

void FileProperties_t::
suppress (const SuppressType& x)
{
  this->suppress_.set (x);
}

void FileProperties_t::
suppress (const SuppressOptional& x)
{
  this->suppress_ = x;
}

const FileProperties_t::DisabledOptional& FileProperties_t::
disabled () const
{
  return this->disabled_;
}

FileProperties_t::DisabledOptional& FileProperties_t::
disabled ()
{
  return this->disabled_;
}

void FileProperties_t::
disabled (const DisabledType& x)
{
  this->disabled_.set (x);
}

void FileProperties_t::
disabled (const DisabledOptional& x)
{
  this->disabled_ = x;
}


// File_t
// 

const File_t::PropertiesSequence& File_t::
Properties () const
{
  return this->Properties_;
}

File_t::PropertiesSequence& File_t::
Properties ()
{
  return this->Properties_;
}

void File_t::
Properties (const PropertiesSequence& s)
{
  this->Properties_ = s;
}

const File_t::ClsidType& File_t::
clsid () const
{
  return this->clsid_.get ();
}

File_t::ClsidType& File_t::
clsid ()
{
  return this->clsid_.get ();
}

void File_t::
clsid (const ClsidType& x)
{
  this->clsid_.set (x);
}

void File_t::
clsid (::std::unique_ptr< ClsidType > x)
{
  this->clsid_.set (std::move (x));
}

const File_t::NameType& File_t::
name () const
{
  return this->name_.get ();
}

File_t::NameType& File_t::
name ()
{
  return this->name_.get ();
}

void File_t::
name (const NameType& x)
{
  this->name_.set (x);
}

void File_t::
name (::std::unique_ptr< NameType > x)
{
  this->name_.set (std::move (x));
}

const File_t::ImageOptional& File_t::
image () const
{
  return this->image_;
}

File_t::ImageOptional& File_t::
image ()
{
  return this->image_;
}

void File_t::
image (const ImageType& x)
{
  this->image_.set (x);
}

void File_t::
image (const ImageOptional& x)
{
  this->image_ = x;
}

const File_t::ChangedOptional& File_t::
changed () const
{
  return this->changed_;
}

File_t::ChangedOptional& File_t::
changed ()
{
  return this->changed_;
}

void File_t::
changed (const ChangedType& x)
{
  this->changed_.set (x);
}

void File_t::
changed (const ChangedOptional& x)
{
  this->changed_ = x;
}

void File_t::
changed (::std::unique_ptr< ChangedType > x)
{
  this->changed_.set (std::move (x));
}

const File_t::UidType& File_t::
uid () const
{
  return this->uid_.get ();
}

File_t::UidType& File_t::
uid ()
{
  return this->uid_.get ();
}

void File_t::
uid (const UidType& x)
{
  this->uid_.set (x);
}

void File_t::
uid (::std::unique_ptr< UidType > x)
{
  this->uid_.set (std::move (x));
}

const File_t::DescOptional& File_t::
desc () const
{
  return this->desc_;
}

File_t::DescOptional& File_t::
desc ()
{
  return this->desc_;
}

void File_t::
desc (const DescType& x)
{
  this->desc_.set (x);
}

void File_t::
desc (const DescOptional& x)
{
  this->desc_ = x;
}

void File_t::
desc (::std::unique_ptr< DescType > x)
{
  this->desc_.set (std::move (x));
}

const File_t::BypassErrorsOptional& File_t::
bypassErrors () const
{
  return this->bypassErrors_;
}

File_t::BypassErrorsOptional& File_t::
bypassErrors ()
{
  return this->bypassErrors_;
}

void File_t::
bypassErrors (const BypassErrorsType& x)
{
  this->bypassErrors_.set (x);
}

void File_t::
bypassErrors (const BypassErrorsOptional& x)
{
  this->bypassErrors_ = x;
}

const File_t::UserContextOptional& File_t::
userContext () const
{
  return this->userContext_;
}

File_t::UserContextOptional& File_t::
userContext ()
{
  return this->userContext_;
}

void File_t::
userContext (const UserContextType& x)
{
  this->userContext_.set (x);
}

void File_t::
userContext (const UserContextOptional& x)
{
  this->userContext_ = x;
}

const File_t::RemovePolicyOptional& File_t::
removePolicy () const
{
  return this->removePolicy_;
}

File_t::RemovePolicyOptional& File_t::
removePolicy ()
{
  return this->removePolicy_;
}

void File_t::
removePolicy (const RemovePolicyType& x)
{
  this->removePolicy_.set (x);
}

void File_t::
removePolicy (const RemovePolicyOptional& x)
{
  this->removePolicy_ = x;
}

const File_t::StatusOptional& File_t::
status () const
{
  return this->status_;
}

File_t::StatusOptional& File_t::
status ()
{
  return this->status_;
}

void File_t::
status (const StatusType& x)
{
  this->status_.set (x);
}

void File_t::
status (const StatusOptional& x)
{
  this->status_ = x;
}

void File_t::
status (::std::unique_ptr< StatusType > x)
{
  this->status_.set (std::move (x));
}


// Files
// 

const Files::FileSequence& Files::
File () const
{
  return this->File_;
}

Files::FileSequence& Files::
File ()
{
  return this->File_;
}

void Files::
File (const FileSequence& s)
{
  this->File_ = s;
}

const Files::ClsidType& Files::
clsid () const
{
  return this->clsid_.get ();
}

Files::ClsidType& Files::
clsid ()
{
  return this->clsid_.get ();
}

void Files::
clsid (const ClsidType& x)
{
  this->clsid_.set (x);
}

void Files::
clsid (::std::unique_ptr< ClsidType > x)
{
  this->clsid_.set (std::move (x));
}

const Files::DisabledOptional& Files::
disabled () const
{
  return this->disabled_;
}

Files::DisabledOptional& Files::
disabled ()
{
  return this->disabled_;
}

void Files::
disabled (const DisabledType& x)
{
  this->disabled_.set (x);
}

void Files::
disabled (const DisabledOptional& x)
{
  this->disabled_ = x;
}


#include <xsd/cxx/xml/dom/wildcard-source.hxx>

#include <xsd/cxx/xml/dom/parsing-source.hxx>

#include <xsd/cxx/tree/type-factory-map.hxx>

namespace _xsd
{
  static
  const ::xsd::cxx::tree::type_factory_plate< 0, char >
  type_factory_plate_init;
}

// FileProperties_t
//

FileProperties_t::
FileProperties_t (const TargetPathType& targetPath)
: ::xml_schema::Type (),
  action_ (this),
  fromPath_ (this),
  targetPath_ (targetPath, this),
  readOnly_ (this),
  archive_ (this),
  hidden_ (this),
  executable_ (this),
  suppress_ (this),
  disabled_ (this)
{
}

FileProperties_t::
FileProperties_t (const FileProperties_t& x,
                  ::xml_schema::Flags f,
                  ::xml_schema::Container* c)
: ::xml_schema::Type (x, f, c),
  action_ (x.action_, f, this),
  fromPath_ (x.fromPath_, f, this),
  targetPath_ (x.targetPath_, f, this),
  readOnly_ (x.readOnly_, f, this),
  archive_ (x.archive_, f, this),
  hidden_ (x.hidden_, f, this),
  executable_ (x.executable_, f, this),
  suppress_ (x.suppress_, f, this),
  disabled_ (x.disabled_, f, this)
{
}

FileProperties_t::
FileProperties_t (const ::xercesc::DOMElement& e,
                  ::xml_schema::Flags f,
                  ::xml_schema::Container* c)
: ::xml_schema::Type (e, f | ::xml_schema::Flags::base, c),
  action_ (this),
  fromPath_ (this),
  targetPath_ (this),
  readOnly_ (this),
  archive_ (this),
  hidden_ (this),
  executable_ (this),
  suppress_ (this),
  disabled_ (this)
{
  if ((f & ::xml_schema::Flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, false, false, true);
    this->parse (p, f);
  }
}

void FileProperties_t::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::Flags f)
{
  while (p.more_attributes ())
  {
    const ::xercesc::DOMAttr& i (p.next_attribute ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    if (n.name () == "action" && n.namespace_ ().empty ())
    {
      this->action_.set (ActionTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "fromPath" && n.namespace_ ().empty ())
    {
      this->fromPath_.set (FromPathTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "targetPath" && n.namespace_ ().empty ())
    {
      this->targetPath_.set (TargetPathTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "readOnly" && n.namespace_ ().empty ())
    {
      this->readOnly_.set (ReadOnlyTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "archive" && n.namespace_ ().empty ())
    {
      this->archive_.set (ArchiveTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "hidden" && n.namespace_ ().empty ())
    {
      this->hidden_.set (HiddenTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "executable" && n.namespace_ ().empty ())
    {
      this->executable_.set (ExecutableTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "suppress" && n.namespace_ ().empty ())
    {
      this->suppress_.set (SuppressTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "disabled" && n.namespace_ ().empty ())
    {
      this->disabled_.set (DisabledTraits::create (i, f, this));
      continue;
    }
  }

  if (!targetPath_.present ())
  {
    throw ::xsd::cxx::tree::expected_attribute< char > (
      "targetPath",
      "");
  }
}

FileProperties_t* FileProperties_t::
_clone (::xml_schema::Flags f,
        ::xml_schema::Container* c) const
{
  return new class FileProperties_t (*this, f, c);
}

FileProperties_t& FileProperties_t::
operator= (const FileProperties_t& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::Type& > (*this) = x;
    this->action_ = x.action_;
    this->fromPath_ = x.fromPath_;
    this->targetPath_ = x.targetPath_;
    this->readOnly_ = x.readOnly_;
    this->archive_ = x.archive_;
    this->hidden_ = x.hidden_;
    this->executable_ = x.executable_;
    this->suppress_ = x.suppress_;
    this->disabled_ = x.disabled_;
  }

  return *this;
}

FileProperties_t::
~FileProperties_t ()
{
}

static
const ::xsd::cxx::tree::type_factory_initializer< 0, char, FileProperties_t >
_xsd_FileProperties_t_type_factory_init (
  "FileProperties_t",
  "");

// File_t
//

File_t::
File_t (const ClsidType& clsid,
        const NameType& name,
        const UidType& uid)
: ::xml_schema::Type (),
  Properties_ (this),
  clsid_ (clsid, this),
  name_ (name, this),
  image_ (this),
  changed_ (this),
  uid_ (uid, this),
  desc_ (this),
  bypassErrors_ (this),
  userContext_ (this),
  removePolicy_ (this),
  status_ (this)
{
}

File_t::
File_t (const File_t& x,
        ::xml_schema::Flags f,
        ::xml_schema::Container* c)
: ::xml_schema::Type (x, f, c),
  Properties_ (x.Properties_, f, this),
  clsid_ (x.clsid_, f, this),
  name_ (x.name_, f, this),
  image_ (x.image_, f, this),
  changed_ (x.changed_, f, this),
  uid_ (x.uid_, f, this),
  desc_ (x.desc_, f, this),
  bypassErrors_ (x.bypassErrors_, f, this),
  userContext_ (x.userContext_, f, this),
  removePolicy_ (x.removePolicy_, f, this),
  status_ (x.status_, f, this)
{
}

File_t::
File_t (const ::xercesc::DOMElement& e,
        ::xml_schema::Flags f,
        ::xml_schema::Container* c)
: ::xml_schema::Type (e, f | ::xml_schema::Flags::base, c),
  Properties_ (this),
  clsid_ (this),
  name_ (this),
  image_ (this),
  changed_ (this),
  uid_ (this),
  desc_ (this),
  bypassErrors_ (this),
  userContext_ (this),
  removePolicy_ (this),
  status_ (this)
{
  if ((f & ::xml_schema::Flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, true);
    this->parse (p, f);
  }
}

void File_t::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::Flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // Properties
    //
    {
      ::std::unique_ptr< ::xsd::cxx::tree::type > tmp (
        ::xsd::cxx::tree::type_factory_map_instance< 0, char > ().create (
          "Properties",
          "",
          &::xsd::cxx::tree::factory_impl< PropertiesType >,
          false, true, i, n, f, this));

      if (tmp.get () != 0)
      {
        ::std::unique_ptr< PropertiesType > r (
          dynamic_cast< PropertiesType* > (tmp.get ()));

        if (r.get ())
          tmp.release ();
        else
          throw ::xsd::cxx::tree::not_derived< char > ();

        this->Properties_.push_back (::std::move (r));
        continue;
      }
    }

    break;
  }

  while (p.more_attributes ())
  {
    const ::xercesc::DOMAttr& i (p.next_attribute ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    if (n.name () == "clsid" && n.namespace_ ().empty ())
    {
      this->clsid_.set (ClsidTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "name" && n.namespace_ ().empty ())
    {
      this->name_.set (NameTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "image" && n.namespace_ ().empty ())
    {
      this->image_.set (ImageTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "changed" && n.namespace_ ().empty ())
    {
      this->changed_.set (ChangedTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "uid" && n.namespace_ ().empty ())
    {
      this->uid_.set (UidTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "desc" && n.namespace_ ().empty ())
    {
      this->desc_.set (DescTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "bypassErrors" && n.namespace_ ().empty ())
    {
      this->bypassErrors_.set (BypassErrorsTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "userContext" && n.namespace_ ().empty ())
    {
      this->userContext_.set (UserContextTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "removePolicy" && n.namespace_ ().empty ())
    {
      this->removePolicy_.set (RemovePolicyTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "status" && n.namespace_ ().empty ())
    {
      this->status_.set (StatusTraits::create (i, f, this));
      continue;
    }
  }

  if (!clsid_.present ())
  {
    throw ::xsd::cxx::tree::expected_attribute< char > (
      "clsid",
      "");
  }

  if (!name_.present ())
  {
    throw ::xsd::cxx::tree::expected_attribute< char > (
      "name",
      "");
  }

  if (!uid_.present ())
  {
    throw ::xsd::cxx::tree::expected_attribute< char > (
      "uid",
      "");
  }
}

File_t* File_t::
_clone (::xml_schema::Flags f,
        ::xml_schema::Container* c) const
{
  return new class File_t (*this, f, c);
}

File_t& File_t::
operator= (const File_t& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::Type& > (*this) = x;
    this->Properties_ = x.Properties_;
    this->clsid_ = x.clsid_;
    this->name_ = x.name_;
    this->image_ = x.image_;
    this->changed_ = x.changed_;
    this->uid_ = x.uid_;
    this->desc_ = x.desc_;
    this->bypassErrors_ = x.bypassErrors_;
    this->userContext_ = x.userContext_;
    this->removePolicy_ = x.removePolicy_;
    this->status_ = x.status_;
  }

  return *this;
}

File_t::
~File_t ()
{
}

static
const ::xsd::cxx::tree::type_factory_initializer< 0, char, File_t >
_xsd_File_t_type_factory_init (
  "File_t",
  "");

// Files
//

Files::
Files (const ClsidType& clsid)
: ::xml_schema::Type (),
  File_ (this),
  clsid_ (clsid, this),
  disabled_ (this)
{
}

Files::
Files (const Files& x,
       ::xml_schema::Flags f,
       ::xml_schema::Container* c)
: ::xml_schema::Type (x, f, c),
  File_ (x.File_, f, this),
  clsid_ (x.clsid_, f, this),
  disabled_ (x.disabled_, f, this)
{
}

Files::
Files (const ::xercesc::DOMElement& e,
       ::xml_schema::Flags f,
       ::xml_schema::Container* c)
: ::xml_schema::Type (e, f | ::xml_schema::Flags::base, c),
  File_ (this),
  clsid_ (this),
  disabled_ (this)
{
  if ((f & ::xml_schema::Flags::base) == 0)
  {
    ::xsd::cxx::xml::dom::parser< char > p (e, true, false, true);
    this->parse (p, f);
  }
}

void Files::
parse (::xsd::cxx::xml::dom::parser< char >& p,
       ::xml_schema::Flags f)
{
  for (; p.more_content (); p.next_content (false))
  {
    const ::xercesc::DOMElement& i (p.cur_element ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    // File
    //
    {
      ::std::unique_ptr< ::xsd::cxx::tree::type > tmp (
        ::xsd::cxx::tree::type_factory_map_instance< 0, char > ().create (
          "File",
          "",
          &::xsd::cxx::tree::factory_impl< FileType >,
          false, true, i, n, f, this));

      if (tmp.get () != 0)
      {
        ::std::unique_ptr< FileType > r (
          dynamic_cast< FileType* > (tmp.get ()));

        if (r.get ())
          tmp.release ();
        else
          throw ::xsd::cxx::tree::not_derived< char > ();

        this->File_.push_back (::std::move (r));
        continue;
      }
    }

    break;
  }

  while (p.more_attributes ())
  {
    const ::xercesc::DOMAttr& i (p.next_attribute ());
    const ::xsd::cxx::xml::qualified_name< char > n (
      ::xsd::cxx::xml::dom::name< char > (i));

    if (n.name () == "clsid" && n.namespace_ ().empty ())
    {
      this->clsid_.set (ClsidTraits::create (i, f, this));
      continue;
    }

    if (n.name () == "disabled" && n.namespace_ ().empty ())
    {
      this->disabled_.set (DisabledTraits::create (i, f, this));
      continue;
    }
  }

  if (!clsid_.present ())
  {
    throw ::xsd::cxx::tree::expected_attribute< char > (
      "clsid",
      "");
  }
}

Files* Files::
_clone (::xml_schema::Flags f,
        ::xml_schema::Container* c) const
{
  return new class Files (*this, f, c);
}

Files& Files::
operator= (const Files& x)
{
  if (this != &x)
  {
    static_cast< ::xml_schema::Type& > (*this) = x;
    this->File_ = x.File_;
    this->clsid_ = x.clsid_;
    this->disabled_ = x.disabled_;
  }

  return *this;
}

Files::
~Files ()
{
}

#include <ostream>

#include <xsd/cxx/tree/std-ostream-map.hxx>

namespace _xsd
{
  static
  const ::xsd::cxx::tree::std_ostream_plate< 0, char >
  std_ostream_plate_init;
}

::std::ostream&
operator<< (::std::ostream& o, const FileProperties_t& i)
{
  if (i.action ())
  {
    o << ::std::endl << "action: " << *i.action ();
  }

  if (i.fromPath ())
  {
    o << ::std::endl << "fromPath: " << *i.fromPath ();
  }

  o << ::std::endl << "targetPath: " << i.targetPath ();
  if (i.readOnly ())
  {
    o << ::std::endl << "readOnly: " << *i.readOnly ();
  }

  if (i.archive ())
  {
    o << ::std::endl << "archive: " << *i.archive ();
  }

  if (i.hidden ())
  {
    o << ::std::endl << "hidden: " << *i.hidden ();
  }

  if (i.executable ())
  {
    o << ::std::endl << "executable: " << *i.executable ();
  }

  if (i.suppress ())
  {
    o << ::std::endl << "suppress: " << *i.suppress ();
  }

  if (i.disabled ())
  {
    o << ::std::endl << "disabled: " << *i.disabled ();
  }

  return o;
}

static
const ::xsd::cxx::tree::std_ostream_initializer< 0, char, FileProperties_t >
_xsd_FileProperties_t_std_ostream_init;

::std::ostream&
operator<< (::std::ostream& o, const File_t& i)
{
  {
    ::xsd::cxx::tree::std_ostream_map< char >& om (
      ::xsd::cxx::tree::std_ostream_map_instance< 0, char > ());

    for (File_t::PropertiesConstIterator
         b (i.Properties ().begin ()), e (i.Properties ().end ());
         b != e; ++b)
    {
      o << ::std::endl << "Properties: ";
      om.insert (o, *b);
    }
  }

  o << ::std::endl << "clsid: " << i.clsid ();
  o << ::std::endl << "name: " << i.name ();
  if (i.image ())
  {
    o << ::std::endl << "image: " << *i.image ();
  }

  if (i.changed ())
  {
    o << ::std::endl << "changed: " << *i.changed ();
  }

  o << ::std::endl << "uid: " << i.uid ();
  if (i.desc ())
  {
    o << ::std::endl << "desc: " << *i.desc ();
  }

  if (i.bypassErrors ())
  {
    o << ::std::endl << "bypassErrors: " << *i.bypassErrors ();
  }

  if (i.userContext ())
  {
    o << ::std::endl << "userContext: " << *i.userContext ();
  }

  if (i.removePolicy ())
  {
    o << ::std::endl << "removePolicy: " << *i.removePolicy ();
  }

  if (i.status ())
  {
    o << ::std::endl << "status: " << *i.status ();
  }

  return o;
}

static
const ::xsd::cxx::tree::std_ostream_initializer< 0, char, File_t >
_xsd_File_t_std_ostream_init;

::std::ostream&
operator<< (::std::ostream& o, const Files& i)
{
  {
    ::xsd::cxx::tree::std_ostream_map< char >& om (
      ::xsd::cxx::tree::std_ostream_map_instance< 0, char > ());

    for (Files::FileConstIterator
         b (i.File ().begin ()), e (i.File ().end ());
         b != e; ++b)
    {
      o << ::std::endl << "File: ";
      om.insert (o, *b);
    }
  }

  o << ::std::endl << "clsid: " << i.clsid ();
  if (i.disabled ())
  {
    o << ::std::endl << "disabled: " << *i.disabled ();
  }

  return o;
}

#include <istream>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

::std::unique_ptr< ::Files >
Files_ (const ::std::string& u,
        ::xml_schema::Flags f,
        const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0,
    (f & ::xml_schema::Flags::keep_dom) == 0);

  ::xsd::cxx::tree::error_handler< char > h;

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      u, h, p, f));

  h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

  return ::std::unique_ptr< ::Files > (
    ::Files_ (
      std::move (d), f | ::xml_schema::Flags::own_dom, p));
}

::std::unique_ptr< ::Files >
Files_ (const ::std::string& u,
        ::xml_schema::ErrorHandler& h,
        ::xml_schema::Flags f,
        const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0,
    (f & ::xml_schema::Flags::keep_dom) == 0);

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      u, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::Files > (
    ::Files_ (
      std::move (d), f | ::xml_schema::Flags::own_dom, p));
}

::std::unique_ptr< ::Files >
Files_ (const ::std::string& u,
        ::xercesc::DOMErrorHandler& h,
        ::xml_schema::Flags f,
        const ::xml_schema::Properties& p)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      u, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::Files > (
    ::Files_ (
      std::move (d), f | ::xml_schema::Flags::own_dom, p));
}

::std::unique_ptr< ::Files >
Files_ (::std::istream& is,
        ::xml_schema::Flags f,
        const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0,
    (f & ::xml_schema::Flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is);
  return ::Files_ (isrc, f, p);
}

::std::unique_ptr< ::Files >
Files_ (::std::istream& is,
        ::xml_schema::ErrorHandler& h,
        ::xml_schema::Flags f,
        const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0,
    (f & ::xml_schema::Flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is);
  return ::Files_ (isrc, h, f, p);
}

::std::unique_ptr< ::Files >
Files_ (::std::istream& is,
        ::xercesc::DOMErrorHandler& h,
        ::xml_schema::Flags f,
        const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::sax::std_input_source isrc (is);
  return ::Files_ (isrc, h, f, p);
}

::std::unique_ptr< ::Files >
Files_ (::std::istream& is,
        const ::std::string& sid,
        ::xml_schema::Flags f,
        const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0,
    (f & ::xml_schema::Flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
  return ::Files_ (isrc, f, p);
}

::std::unique_ptr< ::Files >
Files_ (::std::istream& is,
        const ::std::string& sid,
        ::xml_schema::ErrorHandler& h,
        ::xml_schema::Flags f,
        const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0,
    (f & ::xml_schema::Flags::keep_dom) == 0);

  ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
  return ::Files_ (isrc, h, f, p);
}

::std::unique_ptr< ::Files >
Files_ (::std::istream& is,
        const ::std::string& sid,
        ::xercesc::DOMErrorHandler& h,
        ::xml_schema::Flags f,
        const ::xml_schema::Properties& p)
{
  ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
  return ::Files_ (isrc, h, f, p);
}

::std::unique_ptr< ::Files >
Files_ (::xercesc::InputSource& i,
        ::xml_schema::Flags f,
        const ::xml_schema::Properties& p)
{
  ::xsd::cxx::tree::error_handler< char > h;

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      i, h, p, f));

  h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

  return ::std::unique_ptr< ::Files > (
    ::Files_ (
      std::move (d), f | ::xml_schema::Flags::own_dom, p));
}

::std::unique_ptr< ::Files >
Files_ (::xercesc::InputSource& i,
        ::xml_schema::ErrorHandler& h,
        ::xml_schema::Flags f,
        const ::xml_schema::Properties& p)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      i, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::Files > (
    ::Files_ (
      std::move (d), f | ::xml_schema::Flags::own_dom, p));
}

::std::unique_ptr< ::Files >
Files_ (::xercesc::InputSource& i,
        ::xercesc::DOMErrorHandler& h,
        ::xml_schema::Flags f,
        const ::xml_schema::Properties& p)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::parse< char > (
      i, h, p, f));

  if (!d.get ())
    throw ::xsd::cxx::tree::parsing< char > ();

  return ::std::unique_ptr< ::Files > (
    ::Files_ (
      std::move (d), f | ::xml_schema::Flags::own_dom, p));
}

::std::unique_ptr< ::Files >
Files_ (const ::xercesc::DOMDocument& doc,
        ::xml_schema::Flags f,
        const ::xml_schema::Properties& p)
{
  if (f & ::xml_schema::Flags::keep_dom)
  {
    ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
      static_cast< ::xercesc::DOMDocument* > (doc.cloneNode (true)));

    return ::std::unique_ptr< ::Files > (
      ::Files_ (
        std::move (d), f | ::xml_schema::Flags::own_dom, p));
  }

  const ::xercesc::DOMElement& e (*doc.getDocumentElement ());
  const ::xsd::cxx::xml::qualified_name< char > n (
    ::xsd::cxx::xml::dom::name< char > (e));

  if (n.name () == "Files" &&
      n.namespace_ () == "")
  {
    ::std::unique_ptr< ::Files > r (
      ::xsd::cxx::tree::traits< ::Files, char >::create (
        e, f, 0));
    return r;
  }

  throw ::xsd::cxx::tree::unexpected_element < char > (
    n.name (),
    n.namespace_ (),
    "Files",
    "");
}

::std::unique_ptr< ::Files >
Files_ (::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d,
        ::xml_schema::Flags f,
        const ::xml_schema::Properties&)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > c (
    ((f & ::xml_schema::Flags::keep_dom) &&
     !(f & ::xml_schema::Flags::own_dom))
    ? static_cast< ::xercesc::DOMDocument* > (d->cloneNode (true))
    : 0);

  ::xercesc::DOMDocument& doc (c.get () ? *c : *d);
  const ::xercesc::DOMElement& e (*doc.getDocumentElement ());

  const ::xsd::cxx::xml::qualified_name< char > n (
    ::xsd::cxx::xml::dom::name< char > (e));

  if (f & ::xml_schema::Flags::keep_dom)
    doc.setUserData (::xml_schema::dom::tree_node_key,
                     (c.get () ? &c : &d),
                     0);

  if (n.name () == "Files" &&
      n.namespace_ () == "")
  {
    ::std::unique_ptr< ::Files > r (
      ::xsd::cxx::tree::traits< ::Files, char >::create (
        e, f, 0));
    return r;
  }

  throw ::xsd::cxx::tree::unexpected_element < char > (
    n.name (),
    n.namespace_ (),
    "Files",
    "");
}

#include <ostream>
#include <xsd/cxx/tree/error-handler.hxx>
#include <xsd/cxx/xml/dom/serialization-source.hxx>

#include <xsd/cxx/tree/type-serializer-map.hxx>

namespace _xsd
{
  static
  const ::xsd::cxx::tree::type_serializer_plate< 0, char >
  type_serializer_plate_init;
}

void
operator<< (::xercesc::DOMElement& e, const FileProperties_t& i)
{
  e << static_cast< const ::xml_schema::Type& > (i);

  // action
  //
  if (i.action ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "action",
        e));

    a << *i.action ();
  }

  // fromPath
  //
  if (i.fromPath ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "fromPath",
        e));

    a << *i.fromPath ();
  }

  // targetPath
  //
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "targetPath",
        e));

    a << i.targetPath ();
  }

  // readOnly
  //
  if (i.readOnly ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "readOnly",
        e));

    a << *i.readOnly ();
  }

  // archive
  //
  if (i.archive ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "archive",
        e));

    a << *i.archive ();
  }

  // hidden
  //
  if (i.hidden ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "hidden",
        e));

    a << *i.hidden ();
  }

  // executable
  //
  if (i.executable ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "executable",
        e));

    a << *i.executable ();
  }

  // suppress
  //
  if (i.suppress ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "suppress",
        e));

    a << *i.suppress ();
  }

  // disabled
  //
  if (i.disabled ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "disabled",
        e));

    a << *i.disabled ();
  }
}

static
const ::xsd::cxx::tree::type_serializer_initializer< 0, char, FileProperties_t >
_xsd_FileProperties_t_type_serializer_init (
  "FileProperties_t",
  "");


void
operator<< (::xercesc::DOMElement& e, const File_t& i)
{
  e << static_cast< const ::xml_schema::Type& > (i);

  // Properties
  //
  {
    ::xsd::cxx::tree::type_serializer_map< char >& tsm (
      ::xsd::cxx::tree::type_serializer_map_instance< 0, char > ());

    for (File_t::PropertiesConstIterator
         b (i.Properties ().begin ()), n (i.Properties ().end ());
         b != n; ++b)
    {
      if (typeid (File_t::PropertiesType) == typeid (*b))
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "Properties",
            e));

        s << *b;
      }
      else
        tsm.serialize (
          "Properties",
          "",
          false, true, e, *b);
    }
  }

  // clsid
  //
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "clsid",
        e));

    a << i.clsid ();
  }

  // name
  //
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "name",
        e));

    a << i.name ();
  }

  // image
  //
  if (i.image ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "image",
        e));

    a << *i.image ();
  }

  // changed
  //
  if (i.changed ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "changed",
        e));

    a << *i.changed ();
  }

  // uid
  //
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "uid",
        e));

    a << i.uid ();
  }

  // desc
  //
  if (i.desc ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "desc",
        e));

    a << *i.desc ();
  }

  // bypassErrors
  //
  if (i.bypassErrors ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "bypassErrors",
        e));

    a << *i.bypassErrors ();
  }

  // userContext
  //
  if (i.userContext ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "userContext",
        e));

    a << *i.userContext ();
  }

  // removePolicy
  //
  if (i.removePolicy ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "removePolicy",
        e));

    a << *i.removePolicy ();
  }

  // status
  //
  if (i.status ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "status",
        e));

    a << *i.status ();
  }
}

static
const ::xsd::cxx::tree::type_serializer_initializer< 0, char, File_t >
_xsd_File_t_type_serializer_init (
  "File_t",
  "");


void
Files_ (::std::ostream& o,
        const ::Files& s,
        const ::xml_schema::NamespaceInfomap& m,
        const ::std::string& e,
        ::xml_schema::Flags f)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0);

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::Files_ (s, m, f));

  ::xsd::cxx::tree::error_handler< char > h;

  ::xsd::cxx::xml::dom::ostream_format_target t (o);
  if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
  {
    h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
  }
}

void
Files_ (::std::ostream& o,
        const ::Files& s,
        ::xml_schema::ErrorHandler& h,
        const ::xml_schema::NamespaceInfomap& m,
        const ::std::string& e,
        ::xml_schema::Flags f)
{
  ::xsd::cxx::xml::auto_initializer i (
    (f & ::xml_schema::Flags::dont_initialize) == 0);

  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::Files_ (s, m, f));
  ::xsd::cxx::xml::dom::ostream_format_target t (o);
  if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
  {
    throw ::xsd::cxx::tree::serialization< char > ();
  }
}

void
Files_ (::std::ostream& o,
        const ::Files& s,
        ::xercesc::DOMErrorHandler& h,
        const ::xml_schema::NamespaceInfomap& m,
        const ::std::string& e,
        ::xml_schema::Flags f)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::Files_ (s, m, f));
  ::xsd::cxx::xml::dom::ostream_format_target t (o);
  if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
  {
    throw ::xsd::cxx::tree::serialization< char > ();
  }
}

void
Files_ (::xercesc::XMLFormatTarget& t,
        const ::Files& s,
        const ::xml_schema::NamespaceInfomap& m,
        const ::std::string& e,
        ::xml_schema::Flags f)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::Files_ (s, m, f));

  ::xsd::cxx::tree::error_handler< char > h;

  if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
  {
    h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
  }
}

void
Files_ (::xercesc::XMLFormatTarget& t,
        const ::Files& s,
        ::xml_schema::ErrorHandler& h,
        const ::xml_schema::NamespaceInfomap& m,
        const ::std::string& e,
        ::xml_schema::Flags f)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::Files_ (s, m, f));
  if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
  {
    throw ::xsd::cxx::tree::serialization< char > ();
  }
}

void
Files_ (::xercesc::XMLFormatTarget& t,
        const ::Files& s,
        ::xercesc::DOMErrorHandler& h,
        const ::xml_schema::NamespaceInfomap& m,
        const ::std::string& e,
        ::xml_schema::Flags f)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::Files_ (s, m, f));
  if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
  {
    throw ::xsd::cxx::tree::serialization< char > ();
  }
}

void
Files_ (::xercesc::DOMDocument& d,
        const ::Files& s,
        ::xml_schema::Flags)
{
  ::xercesc::DOMElement& e (*d.getDocumentElement ());
  const ::xsd::cxx::xml::qualified_name< char > n (
    ::xsd::cxx::xml::dom::name< char > (e));

  if (n.name () == "Files" &&
      n.namespace_ () == "")
  {
    e << s;
  }
  else
  {
    throw ::xsd::cxx::tree::unexpected_element < char > (
      n.name (),
      n.namespace_ (),
      "Files",
      "");
  }
}

::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument >
Files_ (const ::Files& s,
        const ::xml_schema::NamespaceInfomap& m,
        ::xml_schema::Flags f)
{
  ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
    ::xsd::cxx::xml::dom::serialize< char > (
      "Files",
      "",
      m, f));

  ::Files_ (*d, s, f);
  return d;
}

void
operator<< (::xercesc::DOMElement& e, const Files& i)
{
  e << static_cast< const ::xml_schema::Type& > (i);

  // File
  //
  {
    ::xsd::cxx::tree::type_serializer_map< char >& tsm (
      ::xsd::cxx::tree::type_serializer_map_instance< 0, char > ());

    for (Files::FileConstIterator
         b (i.File ().begin ()), n (i.File ().end ());
         b != n; ++b)
    {
      if (typeid (Files::FileType) == typeid (*b))
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "File",
            e));

        s << *b;
      }
      else
        tsm.serialize (
          "File",
          "",
          false, true, e, *b);
    }
  }

  // clsid
  //
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "clsid",
        e));

    a << i.clsid ();
  }

  // disabled
  //
  if (i.disabled ())
  {
    ::xercesc::DOMAttr& a (
      ::xsd::cxx::xml::dom::create_attribute (
        "disabled",
        e));

    a << *i.disabled ();
  }
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

